local AceAddon = AceLibrary("AceAddon-2.0")
local Tablet = AceLibrary("Tablet-2.0")

local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Quests")
L:RegisterTranslations("enUS", function() return {

	["Quests"] = true,
	["Filter"] = true,
	["Filter out quests"] = true,
	
  ["Module description"] = "Questgiver mapnotes for Cartographer",
  
	["Select all"] = true,
	["Select none"] = true,
    
    ["Quest"] = true,
    ["Quest Giver"] = true,
    ["Default"] = true,
    ["Available"] = true,
    ["Active"] = true,
    
} end)

L:RegisterTranslations("koKR", function() return {

	["Quests"] = "퀘스트",
	["Filter"] = "필터",
	["Filter out quests"] = "퀘스트 아웃 필터",

  ["Module description"] = "맵노트에 퀘스트 제공자를 표시합니다.",
  
	["Select all"] = "모두 선택",
	["Select none"] = "선택 없음",
    
    ["Quest"] = "퀘스트",
    ["Quest Giver"] = "퀘스트 제공자",
    ["Default"] = "기본값",
    ["Available"] = "가능",
    ["Active"] = "활성화",
    
} end)

L:RegisterTranslations("deDE", function() return {

--	["Quests"] = true,
	["Filter"] = "Filter",
	["Filter out quests"] = "Quests filtern",
	
  ["Module description"] = "Questgeber-Kartennotizen f\195\188r Cartographer",  
  
	["Select all"] = "Alles ausw\195\164hlen",
	["Select none"] = "Nichts ausw\195\164hlen",
    
  ["Quest"] = "Quest",
  ["Quest Giver"] = "Questgeber",
  ["Default"] = "Standard",
  ["Available"] = "Verf\195\188gbar",
  ["Active"] = "Aktiv",
} end)

L:RegisterTranslations("zhTW", function() return {

--	["Quests"] = true,
	["Filter"] = "篩檢",
	["Filter out quests"] = "篩檢任務",
	
  ["Module description"] = "Cartographer 任務給予人地圖註記",
  
	["Select all"] = "全部選擇",
	["Select none"] = "全部取消",
    
    ["Quest"] = "任務",
    ["Quest Giver"] = "任務給予人",
    ["Default"] = "預設",
    ["Available"] = "可取得",
    ["Active"] = "開啟",
    
} end)

L:RegisterTranslations("esES", function() return {

--	["Quests"] = true,
	["Filter"] = "Filtrar",
	["Filter out quests"] = "Filtra misiones",
	
  ["Module description"] = "Notas de mapa de proveedores de misi\195\179n para Cartographer",
  
	["Select all"] = "Seleccionar todo",
	["Select none"] = "No seleccionar nada",
    
    ["Quest"] = "Misi\195\179n",
    ["Quest Giver"] = "Proveedor de misi\195\179n",
    ["Default"] = "Por defecto",
    ["Available"] = "Disponible",
    ["Active"] = "Activo",
    
} end)

local mod
if AceLibrary:HasInstance("AceDebug-2.0") then 
    mod = Cartographer:NewModule("Quests", "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceDebug-2.0")
    mod:SetDebugging(false)
else
    mod = Cartographer:NewModule("Quests", "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
    -- mod.Debug = function() return end
end

mod:RegisterDB("Cartographer_QuestsDB")

mod.icon = {
	["Quest"] = {
		text = L["Quest"],
		path = "Interface\\Icons\\INV_Misc_Book_08",
		width = 12,
		height = 12
	},
}

mod.givers = {}

function mod:OnInitialize()
	self:RegisterDefaults("profile", {
		filter = {
			['*'] = true,
		}
	})

	local aceopts = {}
	aceopts.toggle = {
		name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
		desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
		type  = 'toggle',
		order = -1,
		get   = function() return Cartographer:IsModuleActive(self) end,
		set   = function() Cartographer:ToggleModuleActive(self) end,
	}

    --[[
	aceopts.filter = {
		name = L["Filter"],
		desc = L["Filter out quests"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingQuests(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingQuests(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		}
	}
	for k,v in pairs(self.icon) do
		local k = k
		aceopts.filter.args[k] = {
			name = v.text,
			desc = v.text,
			type = 'toggle',
			get = function()
				return self:IsShowingQuests(k)
			end,
			set = function(value)
				return self:ToggleShowingQuests(k, value)
			end,
		}
	end
    --]]
    
	Cartographer.options.args["Quests"] = {
		name = L["Quests"],
		desc = L["Module description"],
		type = 'group',
		args = aceopts,
		handler = self,
	}
	-- AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, Cartographer.options.args["Quests"])

    if (not self.db.faction.notes) then self.db.faction.notes = {} end

    local oldDB = Cartographer:AcquireDBNamespace("Quests")
    if (oldDB.faction.notes) then
        for k, v in pairs(oldDB.faction.notes) do
            if (k ~= "version") and (v ~= nil) then
                if (not self.db.faction.notes[k]) then self.db.faction.notes[k] = {} end
                for vk, vv in pairs(v) do
                    if (vv ~= nil) then
                        if (not self.db.faction.notes[k][vk]) then
                            -- self.db.faction.notes[k][vk] = {}
                            self.db.faction.notes[k][vk] = vv
                        end
                    end
                end
            end
        end
    end
    oldDB = nil
end

function mod:OnEnable()
	if Cartographer_Notes then
		if not self.iconsregistered then
			for k,v in pairs(self.icon) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end

		Cartographer_Notes:RegisterNotesDatabase('Quests', self.db.faction.notes, self)
	else
		Cartographer:ToggleModuleActive(self, false)
	end

    -- self:RegisterEvent("GOSSIP_SHOW", 2)
    -- self:RegisterEvent("QUEST_DETAIL", function() self:RegisterQuest(UnitName("NPC"), GetTitleText()) end, 2)
    self:RegisterEvent("QUEST_DETAIL", function() self:RegisterQuestGiver(UnitName("NPC")) end, 2)
end

function mod:OnDisable()
	self:UnregisterAllEvents()

	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Quests')
	end
end

function mod:SetNote(giver)
	local x, y = GetPlayerMapPosition("player")
	if x == 0 and y == 0 then return end
	local zone = GetRealZoneText()
    
    local note = {}
    note.icon = L["Quest"]
    note.title = giver.name
    if (giver.quests) then
        if (giver.quests.available) then
            note.info = ""
            for k, v in ipairs(giver.quests.available) do
                if (v ~= nil) then
                    if (note.info:len() == 0) then note.info = L["Available"] .. ":\n"
                    else note.info = note.info .. "\n" end
                    note.info = note.info .. v.title
                end
            end
        end
        
        if (giver.quests.active) then
            note.info2 = ""
            for k, v in ipairs(giver.quests.active) do
                if (v ~= nil) then
                    if (note.info2:len() == 0) then note.info2 = L["Active"] .. ":\n"
                    else note.info2 = note.info2 .. "\n" end
                    note.info2 = note.info2 .. v.title
                end
            end
        end
        
        note.title = note.title .. " - " .. L["Quest Giver"]
    else
        note.info = L["Quest Giver"]
    end
    
	for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(zone, x, y, 5, "Quests", nil, true) do
		if data.title == note.title then
			Cartographer_Notes:DeleteNote(zone, x_p, y_p)
		end
	end
	Cartographer_Notes:SetNote(zone, x, y, note.icon, "Quests", note)
end

function mod:GOSSIP_SHOW()
    -- self:Debug("GOSSIP_SHOW")
    
    local giver = UnitName("NPC")
    
    t1,l1, t2,l2, t3,l3, t4,l4, t5,l5 = GetGossipActiveQuests()
    
    local active = {}
    if (t1) then
        active[1] = {}
        active[1].title = t1
        active[1].level = l1
    end

    if (t2) then
        active[2] = {}
        active[2].title = t2
        active[2].level = l2
    end

    if (t3) then
        active[3] = {}
        active[3].title = t3
        active[3].level = l3
    end

    if (t4) then
        active[4] = {}
        active[4].title = t4
        active[4].level = l4
    end

    if (t5) then
        active[5] = {}
        active[5].title = t5
        active[5].level = l5
    end
    
    t1,l1, t2,l2, t3,l3, t4,l4, t5,l5 = GetGossipAvailableQuests()
    
    local available = {}
    if (t1) then
        available[1] = {}
        available[1].title = t1
        available[1].level = l1
    end

    if (t2) then
        available[2] = {}
        available[2].title = t2
        available[2].level = l2
    end

    if (t3) then
        available[3] = {}
        available[3].title = t3
        available[3].level = l3
    end

    if (t4) then
        available[4] = {}
        available[4].title = t4
        available[4].level = l4
    end

    if (t5) then
        available[5] = {}
        available[5].title = t5
        available[5].level = l5
    end

    if (not mod.givers) then mod.givers = {} end
    if (not mod.givers[giver]) then
        mod.givers[giver] = {}
        mod.givers[giver].name = giver
    end
    
    mod.givers[giver].quests = {}
    mod.givers[giver].quests.active = active
    mod.givers[giver].quests.available = available

    self:SetNote(mod.givers[giver])    
end

function mod:RegisterQuestGiver(giver)
    if (not giver) then return end
    if (type(giver) ~= "string") then return end
    
    if (not mod.givers) then mod.givers = {} end
    if (not mod.givers[giver]) then 
        mod.givers[giver] = {} 
        mod.givers[giver].name = giver
    end
    
    self:SetNote(mod.givers[giver])
end


function mod:RegisterQuest(giver, quest)
    if (not giver) then return end
    if (type(giver) ~= "string") then return end
    
    if (not quest) then return end
    if (type(quest) == "string") then
        local name = quest
        quest = {}
        quest.name = name
    end
    if (type(quest) ~= "table") then return end
    
    if (not mod.givers) then mod.givers = {} end
    if (not mod.givers[giver]) then 
        mod.givers[giver] = {} 
        mod.givers[giver].name = giver
    end
    if (not mod.givers[giver].quests) then mod.givers[giver].quests = {} end
    -- if (not mod.givers[giver].quests.active) then mod.givers[giver].quests.active = {} end
    -- if (not mod.givers[giver].quests.available) then mod.givers[giver].quests.available = {} end
    
    local match = false
    for k, v in ipairs(mod.givers[giver].quests) do
        if (v ~= nil) then
            if (v.name == quest.name) then 
                match = true
                break
            end
        end
    end
    if (not match) then table.insert(mod.givers[giver].quests, quest) end
    
    self:SetNote(mod.givers[giver])
end

function mod:IsNoteHidden(zone, id, questtype)
	return not self.db.profile.filter[questtype]
end

function mod:IsShowingQuests(quest)
	return self.db.profile.filter[questtype]
end

function mod:ToggleShowingQuests(questtype, value)
	if value == nil then
		value = not self.db.profile.filter[questtype]
	end
	self.db.profile.filter[questtype] = value

	Cartographer_Notes:RefreshMap()
end
